/*
  oled_shapes_examples.c
  http://learn.parallax.com/propeller-c-tutorials 
  This program demos the basic commands needed to set up the oled screen  0.95 96X64 prduct 28087 as well as how to use common function commnads.  
  It covers initialization of oled screen, drawing pixel\s. drawing line\s, and drawing various shapes as well as other fun commands.
  For the full list of commands see oledc.h library.
  Author: Parallax Inc.
  Date:   9/28/2016
*/

#include "simpletools.h"                      // Include simple tools
#include "oledc.h"                            // oledc library

                                              // Define communication pins withing init function oledc_init().
#define SID  6                                // Serial data in.
#define SCLK 7                                // Clock
#define CS   8                                // Chip select.
#define RS   9                                
#define RST  10                                
#define SCRN_ROT 2                            // Screen rotation chosse between  0, 1, 2, 3,


int main()                                    // Main function
{
  
  oledc_init(SID,SCLK,CS,RS,RST,SCRN_ROT);    //Initiate SPI communication.
  
 
  oledc_drawPixel(90,55, WHITE);              //Demo drawing pixels at random coordanates and in different colors.
  oledc_drawPixel(93,50, BLUE);
  oledc_drawPixel(86,49, YELLOW);
  oledc_drawPixel(20,45, MAGENTA);
  oledc_drawPixel(56,20, GREEN);
  oledc_drawPixel(10, 1, CYAN);
  oledc_drawPixel(22,13, PURPLE);
  oledc_drawPixel(40,89, RED);
  oledc_drawPixel(15,90, GREEN);
  oledc_drawPixel(93, 2, WHITE);
  oledc_drawPixel(10,12, WHITE);
  oledc_drawPixel(45,38, BLUE);
  oledc_drawPixel(16,20, YELLOW);
  oledc_drawPixel(30,55, MAGENTA);
  oledc_drawPixel(56,20, GREEN);
  oledc_drawPixel(13,25, CYAN);
  oledc_drawPixel(22,13, PURPLE);
  oledc_drawPixel(45,89, RED);
  oledc_drawPixel(50,45, GREEN);
  oledc_drawPixel(20,70, WHITE); 
  oledc_drawPixel(75,45, GREEN);
  oledc_drawPixel(70,25, WHITE);    
  pause(3000);
  
 // oledc_drawLine(45,0,45,45,WHITE);           //Draw a line.
  //pause(100);
  oledc_drawLine(50,0,45,45,WHITE);
  pause(100);
  oledc_drawLine(55,0,45,45,PINK);
  pause(100);
  oledc_drawLine(60,0,45,45,BLUE);
  pause(100);
  oledc_drawLine(65,0,45,45,RED);
  pause(100);
  oledc_drawLine(70,0,45,45,YELLOW);
  pause(100);
  oledc_drawLine(75,0,45,45,WHITE);
  pause(100);
  oledc_drawLine(80,0,45,45,NAVYBLUE);
  pause(100);
  oledc_drawLine(35,0,45,45,GREEN);
  pause(100);
  oledc_drawLine(30,0,45,45,GRAY);
  pause(100);
  oledc_drawLine(25,0,45,45,ORANGE);
  pause(100);
  oledc_drawLine(20,0,45,45,DARKRED);
  pause(100);
  oledc_drawLine(15,0,45,45,WHITE);
  pause(100);
  oledc_drawLine(10,0,45,45,RASPBERRY);
  pause(1000);
  
  oledc_clear(0,0,oledc_getWidth(),oledc_getHeight()); //Clear entire screen. 
  
  //Drawing and filling in rectangles.         
  oledc_drawRect(40,25, 25,15,WHITE);         // oledc_drawRect(X,Y, Width,Height,Color); 
  pause(1000);                                // Pause to allow user to see effect.
  oledc_fillRect(40,25,25,15,WHITE);
  pause(900);
  oledc_fillRect(50,35,20,25,RED);
  pause(800);
  oledc_fillRect(30,15,25,15,GREEN);
  pause(700);
  oledc_fillRect(40,25,10,7,BLUE);
  pause(500);
  oledc_fillRect(13,22,12,20,CYAN);
  pause(400);
  oledc_fillRect(22,13,15,20,PURPLE);
  pause(200);
  oledc_fillRect(65,48,8,12,BLUE);
  pause(150);
  oledc_fillRect(65,65,18,24,RED);
  pause(100);
  oledc_fillRect(13,22,8,20,YELLOW);
  pause(100);
  oledc_fillRect(80,10,8,20,PURPLE);
  pause(100);
  oledc_fillRect(65,15,8,20,MAGENTA);
  pause(100);
  oledc_fillRect(85,5,8,20,YELLOW);
  pause(100);
  
  oledc_clear(0,0,oledc_getWidth(),oledc_getHeight());//Clear entire screen.
  
 //Drawing and fill in in circles. 
  oledc_drawCircle(25,25,5, BLUE);           // oledc_drawCircle(X,Y,radius, Color);
  pause(1000);                               // Pause to allow time for user to see circle.
  oledc_fillCircle(5,5,5,   BLUE);
  pause(1000);
  oledc_fillCircle(36,16,2,  RED);
  pause(900);
  oledc_fillCircle(55,55,10,YELLOW);
  pause(800);
  oledc_fillCircle(22,22,12,GREEN);
  pause(700);
  oledc_fillCircle(23,44,8,CYAN);
  pause(600);
  oledc_fillCircle(55,33,8,PURPLE);
  pause(500);
  oledc_fillCircle(16,16,10,PINK);
  pause(400);
  oledc_fillCircle(26,36,15,WHITE);
  pause(350);
  oledc_fillCircle(45,18,15,RED);
  pause(300);
  oledc_fillCircle(60,35,15,WHITE);
  pause(250);
  oledc_fillCircle(68,45,25,BLUE);
  pause(200);
  oledc_fillCircle(68,55,30,RED);
  pause(150); 
  oledc_fillCircle(80,10, 25,YELLOW);
  pause(125);
  
  oledc_clear(0,0,oledc_getWidth(),oledc_getHeight());//Clear entire screen.
  pause(300);
    
  //Drawing and fill in triangles.
  oledc_drawTriangle(45,25,25,45,70,50, RED); //oledc_Triangle(X1,Y1, X2,Y2, X3,Y3, Color)
  pause(900);
  oledc_fillTriangle(45,25,25,45,70,50, RED); 
  pause(900);
  oledc_fillTriangle(65,28,16,40,50,21, BLUE);
  pause(800);
  oledc_fillTriangle(30,10,10,30,55,35, PINK);
  pause(600);
  oledc_fillTriangle(20,0,0,20,45,25, YELLOW);
  pause(400);
  oledc_fillTriangle(45,25,25,45,70,50, NAVYBLUE);
  pause(300);
  oledc_fillTriangle(48,25,65,68,53,65, PINK);
  pause(250);
  oledc_fillTriangle(22,39,65,65,18,20, GRAY);
  pause(200);
  oledc_fillTriangle(45,25,25,45,70,50, RASPBERRY);
  pause(150);
  oledc_fillTriangle(40,5,27,73,79,50, MAGENTA);
  pause(100);
  oledc_fillTriangle(35,40,25,16,14,50, PINK);
  pause(100);
  oledc_fillTriangle(15,15,38,40,23,43, DARKRED);
  pause(100);
  oledc_fillTriangle(30,40,45,33,63,40, BLUE);
  pause(100);
  oledc_fillTriangle(20,20,50,65,90,36, ORANGE);
  pause(750);
  
  
  oledc_clear(0,0,oledc_getWidth(),oledc_getHeight());//Clear entire screen.
  
  
}
/**
 * TERMS OF USE: MIT License
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 *  to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */
